function message=buildmessage(operation,scu_id,param,val)

% Carregamento das constantes em memria
data;

% Tratamento dos argumentos em falta
if (nargin<4)                           % Valores default nos campos de dados
    val=zeros(1,USART_SEND_LENGTH-2);
end
if (nargin<3)                           % Parametro a consultar/aplicar
    param=0;
end
if (nargin<2)                           % Slave Controller Unit a considerar
    scu_id=0;
end
if (nargin==0)                          % Tipo de mensagem default
    operation=OP_READ_EXTBUFF;
end

% ===== Construo do pacote de tipo ======================================
% Clculo do padro binrio referente  operao
operation_patt=bitand(bitshift(operation,OPERATION_LOC),OPERATION_MASK);
% Clculo do padro binrio devido ao SCU a lidar
scuID_patt=bitand(bitshift(scu_id,SCUID_LOC),SCUID_MASK);
% Clculo do padro binrio devido ao id do dispositivo
param_patt=bitand(bitshift(param,PARAM_LOC),PARAM_MASK);

% Or entre os vrios padres
type=bitor(bitor(operation_patt,scuID_patt),param_patt);
% =========================================================================

% Construo da restante mensagem

% Truncagem dos dados e converso para inteiro sem sinal
val=[val zeros(1,USART_SEND_LENGTH-2-length(val))];         % Compleo dos dados
val=intunsigned(val(1:USART_SEND_LENGTH-2),8);              % Truncatura dos dados
message=uint8([MESSAGE_REQ,type,val]);  % Mensagem final
