% Leitura dos sensores de Fora de um p.
%
% [reaction,rx,error,errorstr,tries]=readreaction(H,foot)
%
% Entradas:
% H    => Handler das comunicaes com o Master
% foot => P alvo
%
% Sadas:
% reaction => Valores dos sensores de fora
% rx       => Mensagem de baixo nvel recebida
% error    => Cdigo de erro, se existente
% errorstr => String descritiva do erro
% tries    => Nmero de tentativas para efectuar a comunicao
%
% (c) Milton Ruas da Silva, 2006

function [reaction,rx,error,errorstr]=readspecial(H,scu_id)

% Carregamento em memria das constantes
data;

% Construo da mensagem a enviar
message=buildmessage(OP_READ_SENSORS,scu_id,PARAM_SPECIAL);

% Envio da mensagem de request e leitura da resposta
[rx,error,errorstr]=sendmessage(H,message);

% O array servos indica o parametro pedido para cada um dos servos
reaction=[];
if (~error)
    for i=3:USART_RECV_LENGTH, reaction=[reaction double(rx(i))]; end
end
