% Aplicao de uma ordem de actuao a cada componente de um SCU
%
% [rx,error,errorstr]=applyjoint(H,scu_id,param,servos)
%
% Entradas:
% H        => Handler para comunicar com o Master
% scu_id   => Identificador do SCU alvo
% param    => Parametro a aplicar
% servos   => Dados a aplicar
%
% Sadas:
% rx       => Mensagem de baixo nvel recebida
% error    => Cdigo de erro, se existente
% errorstr => String descritiva do erro
%
% (c) Milton Ruas da Silva, 2006

function [rx,error,errorstr]=applyjoint(H,scu_id,param,servos)

% Carregamento em memria das constantes
data;

% Construo da mensagem a enviar
message=buildmessage(OP_APPLY_JOINT,scu_id,param,servos);
% Mensagem de resposta esperada
receive=uint8([MESSAGE_SUCESS message(2:end) zeros(1,USART_RECV_LENGTH-USART_SEND_LENGTH)]);

% Envio da mensagem de request e leitura da resposta
[rx,error,errorstr]=sendmessage(H,message);
