% Pedido de envio de uma sequencia de teste.
%
% [error,errorstr]=testcom(H)
%
% Entradas:
%  handler  -> ID da linha srie.
% Sadas:
%  error    -> Cdigo de erro
%  errorstr -> String descritiva do erro
%
% (c) Milton Ruas da Silva, 2006

function [error,errorstr]=testcom(H)

% Variveis globais
data;

% Mensagem de teste a enviar
message=[MESSAGE_TEST floor(rand(1,4)*256)];
expected=[message 0];

% Reset das comunicaes
[stat,errorstr]=cportreset(H);

% Validando o reset
if (stat==0)
    error=1;
    errorstr=['Erro ao reninicializar os buffers: ' errorstr];
    return;
end

% Envio da mensagem de request e leitura da resposta
[rx,error,errorstr]=sendmessage(H,message);

% Erro na transmisso/recepo?
if (error==1)
    errorstr=['Comunicaes falharam: ' errorstr];

% Validao do tamanho
elseif (length(rx)~=length(expected))
    error=1;
    errorstr='Tamanho da mensagem de resposta no esperado!';

% Validao do contedo da mensagem
elseif (rx~=expected)
    error=1;
    errorstr='Mensagem de resposta diferente da esperada!';
end
