% Limitao das posies a aplicar a determinado SCU
%
% position_final=limit(scuid,position)
% Entrada:
%   scuid: id do SCU a aplicar as posies
%   position: lista de posies a aplicar s 3 juntas
% Sada:
%   position_final: posio limitada a aplicar s juntas

function [position,error,errorstr]=validate(scuid,position)

error=0;
errorstr='OK';

% Posies limite a aplicar a cada SCU
posmin=[-90 -90 -90;
        -90 -90 -65;
        -90 -90 -90;
        -90 -90 -90];

posmax=[ 90  90  90;
         90  90  90;
         90  90  90;
         90  90  90];

% Validao dos argumentos
if (scuid<0 || scuid>min(size(posmin,1),size(posmax,1)))
    error('limit fcn:invalid arg','Argumentos invlidos!');
end

N=size(position,1);

for k=1:N
    % Limitao das posies solicitadas
    for i=1:size(posmin,2)
        if (position(k,i)<posmin(scuid,i))
            position(k,i)=posmin(scuid,i);
            error=1;
        end
    end
    for i=1:size(posmax,2)
        if (position(k,i)>posmax(scuid,i))
            position(k,i)=posmax(scuid,i);
            error=1;
        end
    end
end

if (error==1)
    errorstr='Posies limitadas!';
end