function [t,CoPtraj]=analyse_poly(filename)

% Fechar todas as figuras abertas
close all

% Caractersticas dos elos e das correias de transmisso
footdata;

% Carregar ficheiro com os dados a analisar
load(filename);

% Consies da experincia
fprintf('\nCondies da Experiencia:\n');
fprintf('Pos= (%g,%g,%g) => (%g,%g,%g)\nSpeed=%d\t\tK=[%d %d %d]\n',pos0,posF,speed,K);

% Clculo das trajectrias tericas do CoP
CoPtraj=calctrajectory_poly3(t,pos0,posF,speed/50);

% Clculo do Centro de Presso com base no valor dos sensores de pressao
% medidos
CoPmeas=calccop(reaction,servo,scu);

% Converso dos ngulos dos servos para os angulos das juntas
theta=convert2jointangles(scu,servo,Nrel);
% Clculo da cinemtica directa
% (coordenadas cartesianas do joelho e da anca)
xy=cinematdir(theta,L);

figure(1)
for i=1:3
    
    subplot(2,3,i)
    plot(t,CoPtraj(:,i),'b',t,CoPmeas(:,i),'r','linewidth',2);
    grid on
    title('CoP');
    xlabel('t');
    ylabel(char('w'+i));
    legend('Previsto','Medido');
    
    % Junta do Joelho
    subplot(2,3,i+3)
    plot(t,xy(:,i,1),t,xy(:,i,2),'linewidth',2);
    grid on
    legend('Joelho','Anca');
    xlabel('t');
    ylabel(char('w'+i));
    title('Coordenadas Cartesianas')
end

figure('name','ngulos reais das juntas');
lgd=['P (ortogonal)';
     'P (paralelo) ';
     'Joelho        '];
for i=1:3
    subplot(3,1,i)
    plot(t,theta(:,i),'linewidth',2);
    grid on
    xlabel('t');
    ylabel('Posio (graus)');
    title(lgd(i,:));
end
