function xy=analyse_static(filename)

% Fechar todas as figuras abertas
close all
clc

% Caractersticas dos elos e das correias de transmisso
footdata;

% Parametros de compensao do controlador Jacobiano
K=[50 50 50];

% Carregar ficheiro com os dados a analisar
s=load(filename);

% Consies da experincia
fprintf('\nCondies da Experiencia:\n');
fprintf('CoP=(%g,%g,%g) => (%g,%g,%g)\nSteps=%d\n',s.pos0,s.posF,s.steps);

% Clculo do Centro de Presso com base no valor dos sensores de pressao
% medidos
CoPmeas=calccop(s.reaction,s.servo,s.scu);

% Converso dos ngulos dos servos para os angulos das juntas
theta=convert2jointangles(s.scu,s.servo,Nrel);
% Clculo da cinemtica directa
% (coordenadas cartesianas do joelho e da anca)
xy=cinematdir(theta,L);

figure('name','Centro de Presso referncia VS Centro de Presso medido','position',[100 100 1000 600])
for i=1:2
    for j=1:2
        subplot(2,2,i+(j-1)*2)
        plot(s.pos_list(:,j),s.pos_list(:,i),'b.',s.pos_list(:,j),CoPmeas(:,i),'r','linewidth',2);
        grid on
        title(['CoP medido (' char('w'+i) ') VS CoP ref.(' char('w'+j) ')']);
        xlabel('CoP referncia');
        ylabel('CoP medido');
    end
end

figure('name','Coordenadas cartesianas das juntas VS Centro de Presso referncia','position',[100 100 1000 600])
for i=1:2
    for j=1:2
        subplot(2,2,i+(j-1)*2)
        plot(s.pos_list(:,j),xy(:,i,1),'b',s.pos_list(:,j),xy(:,i,2),'r','linewidth',2);
        grid on
        legend('Joelho','Anca');
        title(['Coordenada (' char('w'+i) ') VS CoP ref.(' char('w'+j) ')']);
        xlabel('CoP actuado');
        ylabel('Posio (cm)');
    end
end

disp 'Variao:'
delta=s.pos_list(end,:)-s.pos_list(1,:)

disp 'Variao cartesiana do joelho:'
xy(end,:,1)-xy(1,:,1)

disp 'Variao cartesiana da Anca:'
xy(end,:,2)-xy(1,:,2)
