% Desenho da base do p com a indicao do centro de massa projectado nele.
%
% drawfoot(CoPfoot)
%
% CoPfoot -> Centro de massa projecto no plano do p (CoPx,CoPy,0)
%
% (c) Milton Ruas da Silva, 20/06/2006

function drawfoot(CoMfoot)

% Incluso dos dados do p
footdata;

% Desenho do p
fill([-footW/2 footW/2 footW/2 -footW/2],[footL/2 footL/2 -footL/2 -footL/2],'w')

hold on

% Desenho de cada placa
dw=plateW/2;
dl=plateL/2;
for i=1:length(plate_locx)
    fill([plate_locx(i)-dw,plate_locx(i)+dw,plate_locx(i)+dw,plate_locx(i)-dw], ...
         [plate_locy(i)+dl,plate_locy(i)+dl,plate_locy(i)-dl,plate_locy(i)-dl],'g');
end

% Desenho de cada sensor
plot(sensor_locx,sensor_locy,'x','linewidth',2)

% Desenho do centro de presso ideal
plot(0,0,'or');
% Desenho do centro de massa projectado
if (abs(CoMfoot(1))<=footW/2 && abs(CoMfoot(2))<=footL/2)
    plot(CoMfoot(1),CoMfoot(2),'+k')
    text(CoMfoot(1),CoMfoot(2)+0.5,'CoM')
end

hold off

axis('off')
axis('equal')