% Movimento das tres juntas de uma perna
% H   => Handle das comunicaes
% leg => Posies das tres juntas da perna

function [error,errorstr]=motion(H,leg,speed)

% Inicializao dos parametros de sada
error=0;
errorstr='OK';

% Endereos dos SCUs
scu_id=[2 4];

% Dados da perna
footdata;

% Clculo das posies a aplicar a cada SCU
pos=[     0  leg(1) leg(2);
     leg(3)      0       0];
 
% Adaptao
for i=1:length(scu_id)
    % Converso para os angulos dos servos
    [pos(i,:),error,errorstr]=convert2servoangles(scu_id(i),pos(i,:),Nrel);
    if (error==1), return, end
end

for i=1:length(scu_id)
    % Aplicar velocidade
    [x,error,errorstr]=applyjoint(H,scu_id(i),1,[speed speed speed]);
    if (error==1), return, end
    
    % Aplicar nova posio
    [x,error,errorstr]=applyjoint(H,scu_id(i),0,pos(i,:));
    if (error==1), return, end
end