close all
clc

for i=1:7
    
%     switch i
%         case 1
%             data=load('cop_control_motionxx.mat');
%             description='Variao do plano segundo o eixo orientado pelo p (yy)';
%             fprintf('Aplicou-se uma inclinao no plano segundo o eixo paralelo a linha do p (eixo yy).\n');
%         case 2
%             data=load('cop_control_motionyy.mat');
%             description='Variao do plano segundo o eixo perpendicular ao p (xx)';
%             fprintf('Aplicou-se uma inclinao no plano segundo o eixo perpendicular a linha do p (eixo xx).\n');
%         case 3
%             data=load('cop_control_motionxy.mat');
%             description='Variao do plano obliquamente ao p (eixos xx e yy)';
%             fprintf('Aplicou-se uma inclinao no plano segundo os eixos xx e yy.\n');
%         case 4
%             data=load('cop_control_PressingEachSensor.mat');
%             description='Presso isolada sobre cada um dos sensores de fora';
%             fprintf('Premiu-se com a mo cada um dos sensores de fora.\n');
%         case 5
%             data=load('cop_control_pressingMiddlePointBetweenSensors.mat');
%             description='Presso sobre o ponto intermdio entre cada par de sensores (frente trs e lados)';
%             fprintf('Premiu-se com a mo o ponto central de cada par de sensores (frente, trs e lados).\n');
%         case 6
%             data=load('cop_control_footLifted.mat');
%             description='Aplicao de choques bruscos na perna de modo a fazer levantar o p';
%             fprintf('Aplicaram-se choques repentinos na perna de modo a provocar elevao do p.\n');
%             fprintf('Desta forma verifica-se um erro entre o CoP medido e o CoM.\n');
%         case 7
%             data=load('cop_control_legLifted.mat');
%             description='Levantamento da perna no ar';
%             fprintf('Levantou-se a perna no ar.\n');
%     end
        
    t=data.t;
    CoP=data.CoP;
    servo=data.servo;
    current=data.current;
    
    h=figure(i);
    set(h,'name',description);
    
    subplot(3,1,1);
    plot(t,CoP(:,1),'b',t,CoP(:,2),'g');
    title('Center of Pressure over the foot surface');
    xlabel('time (s)');
    ylabel('CoP (Cm)');
    legend('XX component (perpendicular to foot)','YY component (parallel to foot)');

    subplot(3,1,2)
    plot(t,servo(:,1),'b',t,servo(:,2),'g')
    title('Servo positions');
    xlabel('time (s)');
    ylabel('Position (degrees)');
    legend('Servo 0 (XX)','Servo 1 (YY)');

    subplot(3,1,3)
    plot(t,current(:,1),'b',t,current(:,2),'g')
    title('Mean current drained by each servomotor');
    xlabel('time (s)');
    ylabel('Current drainning %');
    legend('Servo 0 (XX)','servo 1 (YY)');

    input('Pressione ENTER para visualizar os resultados ...');
    fprintf('\n');
end
    