% Adaptao dos angulos solicitados ao que os motores requerem
%
% pos_final=adaptate(scuid,position)
%
% scuid    -> ID do slave
% position -> Posio solicitada
% pos_final-> Posio a aplicar aos servos
%
% Note que a correco nem a limitao  executada.

function pos_final=adaptate(scuid,position)

% Sinal a adicionar as posies solicitadas
signal=[-1 +1 +1;
        +1 -1 -1;
        -1 +1 +1;
        +1 +1 +1];

% Offset a adicionar as posies solicitadas
offset=[   0   0 -70;
           0   0 +70;
           0   0   0;
           0   0   0];

% Validao dos argumentos
if (scuid<1 || length(position)>min(size(signal,2),size(offset,2)))
    error('limit fcn:invalid arg','Argumentos invlidos!');
end
if (scuid>min(size(signal,1),size(offset,1)))
    pos_final=position;
    return;
end

% Adpato da posio solicitada para aplicao aos motores
pos_final = position.*signal(scuid,:) + offset(scuid,:);