% Script de correco das posies aplicadas nas juntas
%
% position_final=correct(scuid,position)
% Entrada:
%   scuid: id do SCU a aplicar as posies
%   position: lista de posies a aplicar s 3 juntas
% Sada:
%   position_final: posio corrigida a aplicar s juntas

function position_final=correct(scuid,position)

% Desvios de posio de cada unidade de controlo
calib=[-10  10 -5;       % SCU 1: Perna direedit ita  (tornozelo + p + joelho)
       -15 -10 -10;       % SCU 2: Perna esquerda (tornozelo + p + joelho)
        5  0   0;       % SCU 3: Anca direita   (mov. dianteiro + lateral + rotativo)
        5  0   0];      % SCU 4: Anca esquerdo  (mov. dianteiro + lateral + rotativo)

% Validao dos argumentos
if (scuid<1 || length(position)~=size(calib,2))
    error('correct fcn:invalid arg','Argumentos invlidos!');
end
if (scuid>size(calib,1))
    position_final=position;
    return;
end

% Correo das posies solicitadas
position_final=position+calib(scuid,:);
