% Clculo das posies a solicitar a cada SCU para realizar um
% movimento de flexo das pernas.
%
% [pos_apply,k,t]=flexao(T,motion)
% T         -> Durao do movimento
% motion    -> Deslocamento a aplicar ao p
% t         -> Array com os instantes temporais para cada movimento
% pos_apply -> Array de posies a aplicar a cada SCU
% k         -> Parametrizao dos controladores PID

function [pos_apply,k,t]=levantar_perna(T,motion,perna)

N_SCU=8;

% Inicializao da varivel de retorno
pos_apply=zeros(N_SCU,3,1);
k=zeros(N_SCU,3,1,4);

% Durao do movimento
t=T;

% Posies a solicitar
if (perna~=2)
    pos_apply(1,:)=[0 0 motion];
    pos_apply(3,:)=[motion 0 0];
end
if (perna~=1)
    pos_apply(2,:)=[0 0 motion];
    pos_apply(4,:)=[motion 0 0];
end

for i=1:N_SCU
    % Adaptao para a posio a aplicar ao servo
    pos_apply(i,:)=adaptate(i,pos_apply(i,:));
    
    % Correco da posio solicitada
    pos_apply(i,:)=correct(i,pos_apply(i,:));
    
    % Limitao
    pos_apply(i,:)=limit(i,pos_apply(i,:));
end
