% Limitao das posies a aplicar a determinado SCU
%
% position_final=limit(scuid,position)
% Entrada:
%   scuid: id do SCU a aplicar as posies
%   position: lista de posies a aplicar s 3 juntas
% Sada:
%   position_final: posio limitada a aplicar s juntas

function position_final=limit(scuid,position)

% Posies mnimas a aplicar a cada SCU
lim_min=[-70 -70 -70;       % SCU 1: Perna direita  (tornozelo + p + joelho)
         -70 -70 -70;       % SCU 2: Perna esquerda (tornozelo + p + joelho)
         -70 -70 -70;       % SCU 3: Anca direita   (mov. dianteiro + lateral + rotativo)
         -70 -70 -70];      % SCU 4: Anca esquerdo  (mov. dianteiro + lateral + rotativo)

lim_max=[ 70  70  70;       % SCU 1: Perna direita  (tornozelo + p + joelho)
          70  70  70;       % SCU 2: Perna esquerda (tornozelo + p + joelho)
          70  70  70;       % SCU 3: Anca direita   (mov. dianteiro + lateral + rotativo)
          70  70  70];      % SCU 4: Anca esquerdo  (mov. dianteiro + lateral + rotativo)

% Validao dos argumentos
if (scuid<1 || length(position)>min(size(lim_min,2),size(lim_max,2)))
    error('limit fcn:invalid arg','Argumentos invlidos!');
end
if (scuid>min(size(lim_min,1),size(lim_max,1)))
    position_final=position;
    return;
end

% Limitao das posies solicitadas
for i=1:length(position)
    if (position(i)<lim_min(scuid,i))
        position(i)=lim_min(scuid,i);
    elseif (position(i)>lim_max(scuid,i))
        position(i)=lim_max(scuid,i);
    end
end

% Retorno
position_final=position;