% Durao do movimento
T=100;

% Clculo de uma trajectria
[pos,k,t]=flexao(T,ang);

% Durao do tick
tick=0.02;

% SCU a amostrar
sample_scu=1;

% Controladores desligados
controller_off;

% Deslocamento do servo para a posio inicial
recycle(H,100,1);

fprintf('Inicializando o servo...\n');
input('Pressione ENTER para ligar controlador... ');

% Controladores ligados
controller;

fprintf('Controlador ligado!\n');
input('Pressione ENTER para iniciar movimento... ');

fprintf('Realizando Movimento...\n');
exe_traj(H,t,pos,k);

% Inicializao de variveis temporrias
position=[];
velocity=[];
current =[];

i=1;
T2=0;
status=one;
while (sum(status(end-2:end))==3)
    [pos,status]=readjoint(H,1,0);
end
while (sum(status(end-2:end))<3 || i<=T2)
    % Leitura dos parametros posio, velocidade e corrente
    [pos,status]=readjoint(H,1,0);
    vel =readjoint(H,1,1);
    curr=readjoint(H,1,2);
    
    % Armazenamento dos dados dos sensores
    position=[position; pos ];
    velocity=[velocity; vel ];
    current =[current ; curr];
    
    if (T2==0 && sum(status(end-2:end))==3)
        T1=i;
        T2=floor(T1*3.0);
    end
    i=i+1;
end

input('Pressione ENTER para reciclar o servo...');
applycontrol(H,1,3,zero);
if (recycle~=0)
    applyjoint(H,1,1,T_slow);
    applyjoint(H,1,0,restPos);
end

fprintf('Efectuando alguns clculos...\n');
% Gama temporal
step=T/T1;
time=[step:step:T2*step]'*tick;
t1=T*tick;
t2=time(end);

% Coeficientes do polinmio descritor da trajectria
delta=posF-pos0;                                % Variao angular
a=[ pos0; zero; 3*delta/t1^2; -2*delta/t1^3];

% Equaes da posio e velocidade
syms t;
posEqu=a(1,:)+a(2,:)*t+a(3,:)*t^2+a(4,:)*t^3;
velEqu=diff(posEqu,t);

% Clculo dos valores esperados
posT=[ones(T2,1).*subs(posEqu(1),time) ones(T2,1).*subs(posEqu(2),time) ones(T2,1).*subs(posEqu(3),time)];
velT=[ones(T2,1).*subs(velEqu(1),time) ones(T2,1).*subs(velEqu(2),time) ones(T2,1).*subs(velEqu(3),time)];
posT(T1+1:end,1)=posF(1);   posT(T1+1:end,2)=posF(2);   posT(T1+1:end,3)=posF(3);
velT(T1+1:end,1)=0;         velT(T1+1:end,2)=0;         velT(T1+1:end,3)=0;

% Nmero de posies armazenadas para estimao da velocidade
N_POS=5;
% Factor de normalizao da corrente medida
N_CURR=52;

h1=figure;
h2=figure;
for i=1:3
    figure(h1);
    
    subplot(3,2,i*2-1);
    plot(time,posT(:,i),time,position(:,i));
    grid on;
    
    subplot(3,2,i*2);
    plot(time,posT(:,i)-position(:,i));
    grid on;
    
    figure(h2);
    
    subplot(3,2,i*2-1);
    plot(time,velT(:,i),time,velocity(:,i)/(tick*N_POS));
    grid on
    
    subplot(3,2,i*2);
    plot(time,current(:,i)/N_CURR);
    axis([0 t2 0 1]);
    grid on
end

array=[time position posT velocity velT current];
save traject.txt array -ASCII -TABS

fprintf('Finished!\n\n');