% Esta funo analisa os resultados medidos pelos sensores de fora e de
% corrente na execuo de movimentos de uma perna fixa pela anca contra o
% solo (descida), e a partir do solo (subida).
% Aqui no so introduzidos objectos estranhos entre o p e o solo, pelo
% que os dados observados referem-se apenas quando o p se encontra, ou
% deixa de se encontrar com o solo.

function analyse_collisiondata(filename)

help analyse_collisiondata

scuid=[2 4];

% Load data
s=load(filename);

% Access data
t=s.t;
pressure=s.pressure;
current=s.current;

% Present graphs
close all
figure(1)
plot(t,pressure(:,1),'b.',t,pressure(:,2),'g.',t,pressure(:,3),'m.',t,pressure(:,4),'r.')
axis([0,t(end),100,220])
xlabel('t');
ylabel('Amplitude');
title('Force Sensors');
legend('Sensor 1','Sensor 2','Sensor 3','Sensor 4');
grid on

figure(2)
plot(t,sum(pressure')'/size(pressure,2),'k.');
axis([0,t(end),100,200])
xlabel('t');
ylabel('Amplitude');
title('Mean Force Sensing')
grid on

for i=1:length(scuid)
    figure(2+i)
    plot(t,current(:,:,i),'linewidth',2);
    xlabel('t');
    ylabel('Current pulse');
    title(['Corrente do ' num2str(i) 'o microcontrolador']);
    legend('Motor 1','Motor 2','Motor 3');
    grid on
end
