function show_force(H,scuid,fig)

% Verificar se temos um handler de comunicaes vlido
if (H==0.0), return, end

% S proceder a medio e desenho se seleccionada a janela correcta
if (gcf~=fig), return, end

% Leitura dos sensores de presso
[special,rx,error,errorstr]=readspecial(H,scuid(1));
if (error==1)
    fprintf('Error reading the pressure sensors: %s\n',errorstr)
    return
end

% Leitura da corrente no primeiro microcontrolador
[curr1,st,rx,error,errorstr]=readjoint(H,scuid(1),2);
if (error==1)
    fprintf('Error reading 1st servomotor: %s\n',errorstr)
    return
end

% Leitura da corrente no segundo microcontrolador
[curr2,st,rx,error,errorstr]=readjoint(H,scuid(2),2);
if (error==1)
    fprintf('Error reading 2nd servomotor: %s\n',errorstr)
    return
end

% Corrente dos motores do primeiro uC + Corrente do 1o motor do 2o uC
curr=[curr1 curr2(:,1)];

% :Sensores de presso
subplot(2,1,1)
bar(1:4,special-128,0.5)
for i=1:4
    text(i+0.05,special(i)-128+sign(special(i)-128)*10,num2str(special(i)));
end
x=axis;
axis([x(1) x(2) -100 100]);
grid on
xlabel('Sensores de fora (superior esquerdo e direito, e inferior esquerdo e direito)')
ylabel('Output-128');
title('SENSORES DE PRESSO');

% :Corrente
subplot(2,1,2)
bar(1:4,curr,0.5)
for i=1:4
    text(i+0.05,curr(i)+5,num2str(curr(i)));
end
x=axis;
axis([x(1) x(2) 0 100]);
grid on
xlabel('Servomotor ortogonal ao p, paralelo ao p, do joelho e da anca')
ylabel('Pulso de corrente');
title('CONSUMO DE CORRENTE');

% Actualizar grficos
drawnow
