% CPORT minitoolbox, version 1.3
%
% The CPORT minitoolbox supplies basic functions to open, configure, read
% from and write to serial and parallel ports under Microsoft Windows 95/98
% and (maybe) NT. The toolbox is implemented using a series of MEX files and
% M files. Requires Windows95/98/NT and Matlab 5+ (tested on Win98+5.1).
%
% Included functions:
% -------------------
%     cportopen      - opens a serial or parallel port for use.
%     cportconfig    - returns/modifies the configuration of a port.
%     cportwrite     - writes characters to a port.
%     cportgetchar   - reads characters from a port.
%     cportgetdouble - reads data (double) from a port.
%     cportgetint    - reads data (integer) from a port.
%     cportgetline   - reads an entire character line from a port.
%     cportputint    - converts data to integer and writes to a port. 
%     cportreset     - resets a port, retrieves error codes and strings and 
%                      flushes its buffers.
%     cportclose     - closes an open port.
%
% C sources are also included, as well as .DLL files compiled under 
% Windows95 using the GCC+RSXNT compiler and development tools. Compilation
% was done according to the batch and configuration files developed by Juergen 
% Bausa (bausa@lfpt.rwth-aachen.de or Juergen.Bausa@T-Online.de). These files
% can be found in the archive RSXMEX.ZIP, available on the Mathworks web server.
%
% The minitoolbox is released into the public domain. Do with it as you will.
%
% Eyal Doron, doron@remon-medical.co.il, July 1999
% Ivo Viscor (Matlab 5.1 problem fix, cportgetchar and cportopen fix,
%             cportgetdouble) ivovi@isibrno.cz, January 2001
% Andrew Walton (cportgetint and cportputint), awalton@otter.co.uk, November 2001.


