/*
 *
 * CPORTClose.C	
 *
 * The calling syntax is:
 *
 *		rc=cportclose(H)
 *
 */

#include <mex.h>
#include <windows.h>

/* Input Arguments */

#define	PORT_IN	prhs[0]

/* Output Arguments */

#define	STATUS	  plhs[0]


void mexFunction(
                 int nlhs,       mxArray *plhs[],
                 int nrhs, const mxArray *prhs[]
		 )
{
  HANDLE	*hp;
  double	*Stat;
  BOOL		ok;

  /* Check for proper number of arguments */
  
  if (nrhs != 1) {
    mexErrMsgTxt("CPORTCLOSE requires one input argument.");
  }
  if (nlhs > 1) {
    mexErrMsgTxt("CPORTCLOSE requires at most one output argument.");
  }
  
  /* Check the type of PORT_IN - should be double */

  if (!mxIsDouble(PORT_IN)) {
    mexErrMsgTxt("CPORTCLOSE first argument should be a file handle.");
  }
  
  /* Assign pointers to the various parameters */

  hp = (HANDLE *)mxGetData(PORT_IN);
  
  /* Do the actual operation */

  /* mexPrintf("%i\n",*(int *)hp); */

  ok = CloseHandle(*hp);

  if (nlhs > 0) {
    STATUS = mxCreateDoubleMatrix(1, 1, mxREAL);
    Stat  = (double *)mxGetPr(STATUS);
    if (ok) *Stat = 1; else *Stat = 0;
  }

  return;
}


