/*
 *
 * CPORTGetChar.C
 *
 * The calling syntax is:
 *
 *		[ch,err]=cportgetchar(H,nchar)
 *
 */

#include <mex.h>
#include <windows.h>

/* Input Arguments */

#define	PORT_IN	 prhs[0]
#define NCHAR_IN prhs[1]

/* Output Arguments */

#define CH_OUT    plhs[0]
#define	STATUS	  plhs[1]


void mexFunction(
                 int nlhs,       mxArray *plhs[],
                 int nrhs, const mxArray *prhs[]
		 )
{
  HANDLE	*hp;
  double	*Stat,*nr;
  char          *ch;
  BOOL          ok;
  DWORD         nRead,nToRead;

  /* Check for proper number of arguments */
  
  if ((nrhs < 1) | (nrhs > 2))
    mexErrMsgTxt("CPORTGETCHAR requires one or two input arguments.");
  if ((nlhs < 1) | (nlhs > 2)) 
    mexErrMsgTxt("CPORTGETCHAR requires one or two output arguments.");
  
  /* Check the type of PORT_IN and assign pointer */

  if (!mxIsDouble(PORT_IN))
    mexErrMsgTxt("CPORTGETCHAR first argument should be a file handle.");
  hp = (HANDLE *)mxGetData(PORT_IN);

  /* if nChar specified */
  if (nrhs==2) {
    if (!mxIsDouble(NCHAR_IN))
      mexErrMsgTxt("CPORTGETCHAR second argument should be a number.");
    nr = mxGetPr(NCHAR_IN); nToRead = *nr;
  } else
    nToRead = 1;

  ch = mxMalloc(nToRead+1); ch[0] = '\0'; ch[nToRead] = '\0';

  ok = (*hp != 0); nRead = 0;

  /* Do it */
  if (ok & !ReadFile(*hp, ch, nToRead, &nRead, NULL)) ok = FALSE; 

  /* Only nRead chars was received */
  ch[nRead]='\0';		
  
  /* Create a matrix for the return arguments */

  CH_OUT = mxCreateString(ch);

  if (nlhs == 2) {
    STATUS = mxCreateDoubleMatrix(1, 1, mxREAL);
    Stat  = (double *)mxGetPr(STATUS);
    if (ok)
      *Stat = 1;
    else
      *Stat = 0;
  }

  mxFree(ch);
  return;
}

