/*
 *
 * CPORTGetDouble.C	
 *
 * The calling syntax is:
 *
 *		[d,err]=cportgetdouble(H,ndbl)
 *
 */

#include <mex.h>
#include <windows.h>

/* Input Arguments */

#define	PORT_IN	 prhs[0]
#define NDBL_IN prhs[1]

/* Output Arguments */

#define D_OUT    plhs[0]
#define	STATUS	  plhs[1]


void mexFunction(
                 int nlhs,       mxArray *plhs[],
                 int nrhs, const mxArray *prhs[]
		 )
{
  HANDLE	*hp;
  double	*Dout,*Stat,*nr;
  char          *ch;
  BOOL          ok;
  DWORD         i,nRead,nToRead;

/* Check for proper number of arguments */
  
  if ((nrhs < 1) | (nrhs > 2))
    mexErrMsgTxt("CPORTGETDOUBLE requires one or two input arguments.");
  if ((nlhs < 1) | (nlhs > 2)) 
    mexErrMsgTxt("CPORTGETDOUBLE requires one or two output arguments.");
  
/* Check the type of PORT_IN and assign pointer */

  if (!mxIsDouble(PORT_IN))
    mexErrMsgTxt("CPORTGETDOUBLE first argument should be a file handle.");
  hp = (HANDLE *)mxGetData(PORT_IN);

/* if ndbl specified */
  if (nrhs==2) {
    if (!mxIsDouble(NDBL_IN))
      mexErrMsgTxt("CPORTGETDOUBLE second argument should be a number.");
    nr = mxGetPr(NDBL_IN); nToRead = *nr;
  } else
    nToRead = 1;

  ch = mxMalloc(nToRead+1); ch[0] = '\0'; ch[nToRead] = '\0';

  ok = (*hp != 0); nRead = 0;

/* Do it */
  if (ok & !ReadFile(*hp, ch, nToRead, &nRead, NULL)) ok = FALSE; 

  
/* Create a matrix for the return arguments */

  D_OUT = mxCreateDoubleMatrix((nRead>0), (int)nRead, mxREAL);
  Dout = (double *)mxGetPr(D_OUT);

  for (i=0; i < nRead; i++)
    Dout[i] =(unsigned char) ch[i];


  if (nlhs == 2) {
    STATUS = mxCreateDoubleMatrix(1, 1, mxREAL);
    Stat  = (double *)mxGetPr(STATUS);
    if (ok)
      *Stat = 1;
    else
      *Stat = 0;
  }

  return;
}


