/*
 *
 * CPORTPurge.C	
 *
 * The calling syntax is:
 *
 *		rc=cportpurge(H)
 *
 */

#include <mex.h>
#include <windows.h>

/* Input Arguments */

#define	PORT_IN	prhs[0]

/* Output Arguments */

#define	STATUS	  plhs[0]


void mexFunction(
                 int nlhs,       mxArray *plhs[],
                 int nrhs, const mxArray *prhs[]
		 )
{
  HANDLE	*hp;
  double	*Stat;

  /* Check for proper number of arguments */
  
  if (nrhs != 1) {
    mexErrMsgTxt("CPORTCLOSE requires one input argument.");
  }
  if (nlhs != 1) {
    mexErrMsgTxt("CPORTCLOSE requires one output argument.");
  }
  
  /* Check the type of PORT_IN - should be double */

  if (!mxIsDouble(PORT_IN)) {
    mexErrMsgTxt("CPORTCLOSE first argument should be a file handle.");
  }
  
  /* Create a matrix for the return arguments */

  STATUS = mxCreateDoubleMatrix(1, 1, mxREAL);

  /* Assign pointers to the various parameters */

  hp = (HANDLE *)mxGetData(PORT_IN);
  Stat  = (double *)mxGetPr(STATUS);
  
  /* Do the actual operation */
  
if (PurgeComm(*hp, PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR))
    *Stat = 1;
  else
    *Stat = 0;

  return;
}


