/*
 *
 * mxadd.C
 *
 * mxArrayToString implementation, added in Matlab 5.2.
 *
 */

#include <mex.h>

char *mxArrayToString( const mxArray *array_ptr)
{
    char *buf;
    int  buflen;
    int  status;

/*
 * Find out how long the input string array is. Note: Users of
 * multibyte character sets should uncomment and use the second 
 * buflen statement that follows and should comment out the first
 * buflen statement that follows.
 */

    /* buflen = (mxGetM(prhs[0]) * mxGetN(prhs[0])) + 1; */
    buflen = (mxGetM( array_ptr )*mxGetN( array_ptr )*sizeof( mxChar )) + 1;

    /* Allocate enough memory to hold the converted string. */
    buf = mxCalloc( buflen, sizeof( char ) );

    /* Copy the string data from array_ptr and place it into buf. */
    status = mxGetString( array_ptr, buf, buflen );

    if (status)
        buf    = NULL;

    return buf;
}

