#ifndef _SERVO_H
#define _SERVO_H

#include "global.h"

#define K_FACTOR 100

typedef struct {
    signed int servo[N_SERVOS];
    signed int cop[N_SERVOS];
    signed int inc[N_SERVOS];
    signed int giro[N_SERVOS];
} struct_sensorHighLevel;
extern struct_sensorHighLevel sensorHighLevel;


// Calibrao dos servos
extern void calibration(void);

// Calibrao do declive para clculo da posio angular
extern bool dynamicServoCalib(signed char posact, byte srv);

// Solicitao de movimento de um servo!
signed char servoRequest(signed char position, byte control_type, byte srv);

// Inicializao do Controlador
extern void initController(void);

// Execuo do controlador
extern void controller(void);

#endif
