#include "global.h"

// Variveis globais descritivas do sistema

struct_sensors   sensors[N_SCU];                  // Sensores

#pragma udata bank1=0x100
struct_actuators actuators[N_SCU];               // Actuadores
#pragma udata

// Posies standard dos servos
static const signed char homePositions[N_SCU][N_SERVOS]=STD_POSITIONS;

void initGlobal(void)
{
    initSensors();

    initActuators();
}

void initSensors(void)
{
    unsigned char i, j;

    // Inicializaos dos sensores dos servos
    for (i=0; i<N_SCU; ++i)  {
        // Estado do sistema
        sensors[i].sysStatus=0;

        for (j=0; j<N_SERVOS; ++j)  {
            sensors[i].servo[j].position=0;
            sensors[i].servo[j].velocity=0;
            sensors[i].servo[j].current =0;            
        }
        // Inicializao dos sensores especiais
        for (j=0; j<N_SPECIAL_SENSORS; ++j)
            sensors[i].special[j]=0;
    }
}

void initActuators(void)
{
    unsigned int i, j;

    // Inicializaos dos actuadores
    for (i=0; i<N_SCU; ++i)  {

        // PWM e calibrao dinmica desactivadas
        actuators[i].sysStatus.pwm=false;
        actuators[i].sysStatus.calib=false;

        for (j=0; j<N_SERVOS; ++j)  {
            // Parmetros dos Controladores das juntas
            actuators[i].control[j].type=NO_CONTROL;
            actuators[i].control[j].ki=0;
            actuators[i].control[j].kp=0;
            actuators[i].control[j].kd=0;

            // Actuadores
            actuators[i].servo[j].position=homePositions[i][j];
            actuators[i].servo[j].velocity=0;
            actuators[i].servo[j].current =0;
        }
    }
}
