/*=======================================================================+
| DEPARTAMENTO MECANICA + DEPARTAMENTO DE ELECTRNICA E TELECOMUNICAES |
|                       DA UNIVERSIDADE AVEIRO                           |
|               Projecto Humanoide (PHUA - MODULROB)                     |
|                                                                        |
| Programadores:                                                         |
|              Milton Ruas da Silva                N:21824 (EET)         |
|              David Manuel Costa Gameiro          N:20281 (DEM)         |
|              Filipe Carvalho Mostardinha         N:22085 (DEM)         |
|                                                                        |
| Nome Ficheiro: global.c                                                |
|                                                                        |
|                              C FILE                                    |
+=======================================================================*/

#include "global.h"

// _____ ESTRUTURAS GLOBAIS DO SISTEMA ________________________________________________________________________________

// Variveis globais descritivas do sistema
volatile struct_sensors   sensors;                        // Sensores
volatile struct_actuators actuators;                      // Actuadores

// _____ FUNES DE INICIALIZAO DO SISTEMA __________________________________________________________________________

// Inicializao de todas as estruturas globais
//
void initGlobal(void)
{
    // Inicializao dos sensores
    initSensors();

    // Inicializao dos actuadores
    initActuators();
}

// Inicializao da estrutura sensores
//
void initSensors(void)
{
    unsigned int j;

    // Estado do sistema
    sensors.sysStatus.pwm=false;
    sensors.sysStatus.calib=false;
    sensors.sysStatus.deadlineError=false;

    // Inicializaos dos sensores e do estado de cada servos
    for (j=0; j<N_SERVOS; ++j)  {
        // Estado de cada servo
        sensors.sysStatus.motionFin[j]=false;           // Trajectria terminada

        // Sensores
        sensors.servo[j].position=0;                    // Posio
        sensors.servo[j].velocity=0;                    // Velocidade
        sensors.servo[j].current =0;                    // Corrente
    }

    // Inicializao dos sensores de fora do p
    for (j=0; j<N_SPECIAL_SENSORS; ++j)  sensors.special[j]=0;
}

// Inicializao da estrutura actuadores
//
void initActuators(void)
{
    unsigned int j;

    // Estado de actuao do sistema
    actuators.sysStatus.pwm=false;                      // PWM on/off
    actuators.sysStatus.calib=false;                   // Filtragem on/off

    // Inicializaos dos actuadores
    for (j=0; j<N_SERVOS; ++j)  {
        // Controlador PID
        actuators.control[j].kp=0;                      // Parmetro Kp
        actuators.control[j].kd=0;                      // Parmetro Kd
        actuators.control[j].ki=0;                      // Parmetro Ki
        actuators.control[j].type=NO_CONTROL;           // Controlador On/Off?

        // Parmetros de actuao
        actuators.servo[j].position=0;                  // Posio
        actuators.servo[j].velocity=0;                  // Velocidade
        actuators.servo[j].current =0;                  // Corrente
    }
}
