#ifndef __REG_18F258_H
#define __REG_18F258_H

#if defined(HI_TECH_C)
    #define HITECH_C18
#else
    #define MCHP_C18
#endif

#if defined(MCHP_C18) && defined(HITECH_C18)
#error "Invalid Compiler selection."
#endif

#if !defined(MCHP_C18) && !defined(HITECH_C18)
#error "Compiler not supported."
#endif

#if defined(MCHP_C18)

    // __________ PORTS __________

    // PORTA register
    #define PORTA_RA0           PORTAbits.RA0
    #define PORTA_RA1           PORTAbits.RA1
    #define PORTA_RA2           PORTAbits.RA2
    #define PORTA_RA3           PORTAbits.RA3
    #define PORTA_RA4           PORTAbits.RA4
    #define PORTA_RA5           PORTAbits.RA5

    // PORTB register
    #define PORTB_RB0           PORTBbits.RB0
    #define PORTB_RB1           PORTBbits.RB1
    #define PORTB_RB2           PORTBbits.RB2
    #define PORTB_RB3           PORTBbits.RB3
    #define PORTB_RB4           PORTBbits.RB4
    #define PORTB_RB5           PORTBbits.RB5
    #define PORTB_RB6           PORTBbits.RB6
    #define PORTB_RB7           PORTBbits.RB7

    // PORTC register
    #define PORTC_RC0           PORTCbits.RC0
    #define PORTC_RC1           PORTCbits.RC1
    #define PORTC_RC2           PORTCbits.RC2
    #define PORTC_RC3           PORTCbits.RC3
    #define PORTC_RC4           PORTCbits.RC4
    #define PORTC_RC5           PORTCbits.RC5
    #define PORTC_RC6           PORTCbits.RC6
    #define PORTC_RC7           PORTCbits.RC7

    // __________ CAN MODULE __________

    // CANCON register
    #define CANCON_REQOP2       CANCONbits.REQOP2
    #define CANCON_REQOP1       CANCONbits.REQOP1
    #define CANCON_REQOP0       CANCONbits.REQOP0
    #define CANCON_ABAT         CANCONbits.ABAT
    #define CANCON_WIN2         CANCONbits.WIN2
    #define CANCON_WIN1         CANCONbits.WIN1
    #define CANCON_WIN0         CANCONbits.WIN0

    // CANSTAT register
    #define CANSTAT_OPMODE2     CANSTATbits.OPMODE2
    #define CANSTAT_OPMODE1     CANSTATbits.OPMODE1
    #define CANSTAT_OPMODE0     CANSTATbits.OPMODE0
    #define CANSTAT_ICODE2      CANSTATbits.ICODE2
    #define CANSTAT_ICODE1      CANSTATbits.ICODE1
    #define CANSTAT_ICODE0      CANSTATbits.ICODE0

    // COMSTAT register
    #define COMSTAT_RXB0OVFL    COMSTATbits.RXB0OVFL
    #define COMSTAT_RXB1OVFL    COMSTATbits.RXB1OVFL
    #define COMSTAT_TXB0        COMSTATbits.TXB0
    #define COMSTAT_TXBP        COMSTATbits.TXBP
    #define COMSTAT_RXBP        COMSTATbits.RXBP
    #define COMSTAT_TXWARN      COMSTATbits.TXWARN
    #define COMSTAT_RXWARN      COMSTATbits.RXWARN
    #define COMSTAT_EWARN       COMSTATbits.EWARN

    // TXB0CON register
    #define TXB0CON_TXABT       TXB0CONbits.TXABT
    #define TXB0CON_TXLARB      TXB0CONbits.TXLARB
    #define TXB0CON_TXERR       TXB0CONbits.TXERR
    #define TXB0CON_TXREQ       TXB0CONbits.TXREQ
    #define TXB0CON_TXPRI1      TXB0CONbits.TXPRI1
    #define TXB0CON_TXPRI0      TXB0CONbits.TXPRI0
    // TXB1CON register
    #define TXB1CON_TXABT       TXB1CONbits.TXABT
    #define TXB1CON_TXLARB      TXB1CONbits.TXLARB
    #define TXB1CON_TXERR       TXB1CONbits.TXERR
    #define TXB1CON_TXREQ       TXB1CONbits.TXREQ
    #define TXB1CON_TXPRI1      TXB1CONbits.TXPRI1
    #define TXB1CON_TXPRI0      TXB1CONbits.TXPRI0
    // TXB2CON register
    #define TXB2CON_TXABT       TXB2CONbits.TXABT
    #define TXB2CON_TXLARB      TXB2CONbits.TXLARB
    #define TXB2CON_TXERR       TXB2CONbits.TXERR
    #define TXB2CON_TXREQ       TXB2CONbits.TXREQ
    #define TXB2CON_TXPRI1      TXB2CONbits.TXPRI1
    #define TXB2CON_TXPRI0      TXB2CONbits.TXPRI0

    // TXB0SIDL register
    #define TXB0SIDL_EXIDE      TXB0SIDLbits.EXIDE
    // TXB1SIDL register
    #define TXB1SIDL_EXIDE      TXB1SIDLbits.EXIDE
    // TXB2SIDL register
    #define TXB2SIDL_EXIDE      TXB2SIDLbits.EXIDE
    
    // TXB0DLC register
    #define TXB0DLC_TXRTR       TXB0DLCbits.TXRTR
    // TXB1DLC register
    #define TXB1DLC_TXRTR       TXB1DLCbits.TXRTR
    // TXB2DLC register
    #define TXB2DLC_TXRTR       TXB2DLCbits.TXRTR

    // RXB0CON register
    #define RXB0CON_RXFUL       RXB0CONbits.RXFUL
    #define RXB0CON_RXM1        RXB0CONbits.RXM1
    #define RXB0CON_RXM0        RXB0CONbits.RXM0
    #define RXB0CON_RXRTRRO     RXB0CONbits.RXRTRRO
    #define RXB0CON_RXB0DBEN    RXB0CONbits.RXB0DBEN
    #define RXB0CON_JTOFF       RXB0CONbits.JTOFF
    #define RXB0CON_FILHIT0     RXB0CONbits.FILHIT0
    // RXB1CON register
    #define RXB1CON_RXFUL       RXB1CONbits.RXFUL
    #define RXB1CON_RXM1        RXB1CONbits.RXM1
    #define RXB1CON_RXM0        RXB1CONbits.RXM0
    #define RXB1CON_RXRTRRO     RXB1CONbits.RXRTRRO
    #define RXB1CON_FILHIT2     RXB1CONbits.FILHIT2
    #define RXB1CON_FILHIT1     RXB1CONbits.FILHIT1
    #define RXB1CON_FILHIT0     RXB1CONbits.FILHIT0

    // RXB0SIDL register
    #define RXB0SIDL_SRR        RXB0SIDLbits.SRR
    #define RXB0SIDL_EXID       RXB0SIDLbits.EXID
    // RXB1SIDL register
    #define RXB1SIDL_SRR        RXB1SIDLbits.SRR
    #define RXB1SIDL_EXID       RXB1SIDLbits.EXID

    // RXB0DLC register
    #define RXB0DLC_RXRTR       RXB0DLCbits.RXRTR
    #define RXB0DLC_RB1         RXB0DLCbits.RB1
    #define RXB0DLC_RB0         RXB0DLCbits.RB0
    // RXB1DLC register
    #define RXB1DLC_RXRTR       RXB1DLCbits.RXRTR
    #define RXB1DLC_RB1         RXB1DLCbits.RB1
    #define RXB1DLC_RB0         RXB1DLCbits.RB0

    // RXF0SIDL register
    #define RXF0SIDL_EXIDEN     RXF0SIDLbits.EXIDEN
    // RXF1SIDL register
    #define RXF1SIDL_EXIDEN     RXF1SIDLbits.EXIDEN

    // BRGCON1 register
    #define BRGCON1_SJW1        BRGCON1bits.SJW1
    #define BRGCON1_SJW0        BRGCON1bits.SJW0
    #define BRGCON1_BRP5        BRGCON1bits.BRP5
    #define BRGCON1_BRP4        BRGCON1bits.BRP4
    #define BRGCON1_BRP3        BRGCON1bits.BRP3
    #define BRGCON1_BRP2        BRGCON1bits.BRP2
    #define BRGCON1_BRP1        BRGCON1bits.BRP1
    #define BRGCON1_BRP0        BRGCON1bits.BRP0

    // BRGCON2 register
    #define BRGCON2_SEG2PHTS    BRGCON2bits.SEG2PHTS
    #define BRGCON2_SAM         BRGCON2bits.SAM
    #define BRGCON2_SEG1PH2     BRGCON2bits.SEG1PH2
    #define BRGCON2_SEG1PH1     BRGCON2bits.SEG1PH1
    #define BRGCON2_SEG1PH0     BRGCON2bits.SEG1PH0
    #define BRGCON2_PRSEG2      BRGCON2bits.PRSEG2
    #define BRGCON2_PRSEG1      BRGCON2bits.PRSEG1
    #define BRGCON2_PRSEG0      BRGCON2bits.PRSEG0

    // BRGCON3 register
    #define BRGCON3_WAKFIL      BRGCON3bits.WAKFIL
    #define BRGCON3_SEG2PH2     BRGCON3bits.SEG2PH2
    #define BRGCON3_SEG2PH1     BRGCON3bits.SEG2PH1
    #define BRGCON3_SEG2PH0     BRGCON3bits.SEG2PH0

    // __________ USART MODULE __________

    // TXSTA register
    #define TXSTA_CSRC          TXSTAbits.CSRC
    #define TXSTA_TX9           TXSTAbits.TX9
    #define TXSTA_TXEN          TXSTAbits.TXEN
    #define TXSTA_SYNC          TXSTAbits.SYNC
    #define TXSTA_BRGH          TXSTAbits.BRGH
    #define TXSTA_TRMT          TXSTAbits.TRMT
    #define TXSTA_TX9D          TXSTAbits.TX9D

    // RCSTA register
    #define RCSTA_SPEN          RCSTAbits.SPEN
    #define RCSTA_RX9           RCSTAbits.RX9
    #define RCSTA_SREN          RCSTAbits.SREN
    #define RCSTA_CREN          RCSTAbits.CREN
    #define RCSTA_ADDEN         RCSTAbits.ADDEN
    #define RCSTA_FERR          RCSTAbits.FERR
    #define RCSTA_OERR          RCSTAbits.OERR
    #define RCSTA_RX9D          RCSTAbits.RX9D

    // __________ ADC MODULE __________

    // ADCON0 register
    #define ADCON0_ADCS1        ADCON0bits.ADCS1
    #define ADCON0_ADCS0        ADCON0bits.ADCS0
    #define ADCON0_CHS2         ADCON0bits.CHS2
    #define ADCON0_CHS1         ADCON0bits.CHS1
    #define ADCON0_CHS0         ADCON0bits.CHS0
    #define ADCON0_GO           ADCON0bits.GO
    #define ADCON0_ADON         ADCON0bits.ADON

    // ADCON1 register
    #define ADCON1_ADFM         ADCON1bits.ADFM
    #define ADCON1_ADCS2        ADCON1bits.ADCS2
    #define ADCON1_PCFG3        ADCON1bits.PCFG3
    #define ADCON1_PCFG2        ADCON1bits.PCFG2
    #define ADCON1_PCFG1        ADCON1bits.PCFG1
    #define ADCON1_PCFG0        ADCON1bits.PCFG0

    // __________ TIMER MODULES __________

    // T0CON register
    #define T0CON_TMR0ON        T0CONbits.TMR0ON
    #define T0CON_T08BIT        T0CONbits.T08BIT
    #define T0CON_T0CS          T0CONbits.T0CS
    #define T0CON_T0SE          T0CONbits.T0SE
    #define T0CON_PSA           T0CONbits.PSA
    #define T0CON_T0PS2         T0CONbits.T0PS2
    #define T0CON_T0PS1         T0CONbits.T0PS1
    #define T0CON_T0PS0         T0CONbits.T0PS0
    
    // T1CON register
    #define T1CON_RD16          T1CONbits.RD16
    #define T1CON_T1CKPS1       T1CONbits.T1CKPS1
    #define T1CON_T1CKPS0       T1CONbits.T1CKPS0
    #define T1CON_T1OSCEN       T1CONbits.T1OSCEN
    #define T1CON_T1SYNC        T1CONbits.T1SYNC
    #define T1CON_TMR1CS        T1CONbits.TMR1CS
    #define T1CON_TMR1ON        T1CONbits.TMR1ON

    // T2CON register
    #define T2CON_TOUTPS3       T2CONbits.TOUTPS3
    #define T2CON_TOUTPS2       T2CONbits.TOUTPS2
    #define T2CON_TOUTPS1       T2CONbits.TOUTPS1
    #define T2CON_TOUTPS0       T2CONbits.TOUTPS0
    #define T2CON_TMR2ON        T2CONbits.TMR2ON
    #define T2CON_T2CKPS1       T2CONbits.T2CKPS1
    #define T2CON_T2CKPS0       T2CONbits.T2CKPS0

    // T3CON register
    #define T3CON_RD16          T3CONbits.RD16
    #define T3CON_T3ECCP1       T3CONbits.T3ECCP1
    #define T3CON_T3CKPS1       T3CONbits.T3CKPS1
    #define T3CON_T3CKPS0       T3CONbits.T3CKPS0
    #define T3CON_T3CCP1        T3CONbits.T3CCP1
    #define T3CON_T3SYNC        T3CONbits.T3SYNC
    #define T3CON_TMR3CS        T3CONbits.TMR3CS
    #define T3CON_TMR3ON        T3CONbits.TMR3ON

    // __________ INTERRUPT MODULES __________
    
    // INTCON register
    #define INTCON_GIE          INTCONbits.GIE
    #define INTCON_PEIE         INTCONbits.PEIE
    #define INTCON_GIEH         INTCONbits.GIEH
    #define INTCON_GIEL         INTCONbits.GIEL
    #define INTCON_TMR0IE       INTCONbits.TMR0IE
    #define INTCON_INT0IE       INTCONbits.INT0IE
    #define INTCON_RBIE         INTCONbits.RBIE
    #define INTCON_TMR0IF       INTCONbits.TMR0IF
    #define INTCON_INT0IF       INTCONbits.INT0IF
    #define INTCON_RBIF         INTCONbits.RBIF
    // INTCON2 register
    #define INTCON2_RBPU        INTCON2bits.RBPU
    #define INTCON2_INTEDG0     INTCON2bits.INTEDG0
    #define INTCON2_INTEDG1     INTCON2bits.INTEDG1
    #define INTCON2_TMR0IP      INTCON2bits.TMR0IP
    #define INTCON2_RBIP        INTCON2bits.RBIP
    // INTCON3 register
    #define INTCON3_INT2IP      INTCON3bits.INT2IP
    #define INTCON3_INT1IP      INTCON3bits.INT1IP
    #define INTCON3_INT2IE      INTCON3bits.INT2IE
    #define INTCON3_INT1IE      INTCON3bits.INT1IE
    #define INTCON3_INT2IF      INTCON3bits.INT2IF
    #define INTCON3_INT1IF      INTCON3bits.INT1IF

    // RCON register
    #define RCON_IPEN           RCONbits.IPEN
    #define RCON_RI             RCONbits.RI
    #define RCON_TO             RCONbits.TO
    #define RCON_PD             RCONbits.PD
    #define RCON_POR            RCONbits.POR
    #define RCON_BOR            RCONbits.BOR

    // PIR1 register
    #define PIR1_PSPIF          PIR1bits.PSPIF
    #define PIR1_ADIF           PIR1bits.ADIF
    #define PIR1_RCIF           PIR1bits.RCIF
    #define PIR1_TXIF           PIR1bits.TXIF
    #define PIR1_SSPIF          PIR1bits.SSPIF
    #define PIR1_CCP1IF         PIR1bits.CCP1IF
    #define PIR1_TMR2IF         PIR1bits.TMR2IF
    #define PIR1_TMR1IF         PIR1bits.TMR1IF
    // PIR2 register
    #define PIR2_CMIF           PIR2bits.CMIF
    #define PIR2_EEIF           PIR2bits.EEIF
    #define PIR2_BCLIF          PIR2bits.BCLIF
    #define PIR2_LVDIF          PIR2bits.LVDIF
    #define PIR2_TMR3IF         PIR2bits.TMR3IF
    #define PIR2_ECCP1IF        PIR2bits.ECCP1IF
    // PIR3 register
    #define PIR3_IRXIF          PIR3bits.IRXIF
    #define PIR3_WAKIF          PIR3bits.WAKIF
    #define PIR3_ERRIF          PIR3bits.ERRIF
    #define PIR3_TXB2IF         PIR3bits.TXB2IF
    #define PIR3_TXB1IF         PIR3bits.TXB1IF
    #define PIR3_TXB0IF         PIR3bits.TXB0IF
    #define PIR3_RXB1IF         PIR3bits.RXB1IF
    #define PIR3_RXB0IF         PIR3bits.RXB0IF

    // PIE1 register
    #define PIE1_PSPIE          PIE1bits.PSPIE
    #define PIE1_ADIE           PIE1bits.ADIE
    #define PIE1_RCIE           PIE1bits.RCIE
    #define PIE1_TXIE           PIE1bits.TXIE
    #define PIE1_SSPIE          PIE1bits.SSPIE
    #define PIE1_CCP1IE         PIE1bits.CCP1IE
    #define PIE1_TMR2IE         PIE1bits.TMR2IE
    #define PIE1_TMR1IE         PIE1bits.TMR1IE
    // PIE2 register
    #define PIE2_CMIE           PIE2bits.CMIE
    #define PIE2_EEIE           PIE2bits.EEIE
    #define PIE2_BCLIE          PIE2bits.BCLIE
    #define PIE2_LVDIE          PIE2bits.LVDIE
    #define PIE2_TMR3IE         PIE2bits.TMR3IE
    #define PIE2_ECCP1IE        PIE2bits.ECCP1IE
    // PIE3 register
    #define PIE3_IRXIE          PIE3bits.IRXIE
    #define PIE3_WAKIE          PIE3bits.WAKIE
    #define PIE3_ERRIE          PIE3bits.ERRIE
    #define PIE3_TXB2IE         PIE3bits.TXB2IE
    #define PIE3_TXB1IE         PIE3bits.TXB1IE
    #define PIE3_TXB0IE         PIE3bits.TXB0IE
    #define PIE3_RXB1IE         PIE3bits.RXB1IE
    #define PIE3_RXB0IE         PIE3bits.RXB0IE

    // IPR1 register
    #define IPR1_PSPIP          IPR1bits.PSPIP
    #define IPR1_ADIP           IPR1bits.ADIP
    #define IPR1_RCIP           IPR1bits.RCIP
    #define IPR1_TXIP           IPR1bits.TXIP
    #define IPR1_SSPIP          IPR1bits.SSPIP
    #define IPR1_CCP1IP         IPR1bits.CCP1IP
    #define IPR1_TMR2IP         IPR1bits.TMR2IP
    #define IPR1_TMR1IP         IPR1bits.TMR1IP
    // IPR2 register
    #define IPR2_CMIP           IPR2bits.CMIP
    #define IPR2_EEIP           IPR2bits.EEIP
    #define IPR2_BCLIP          IPR2bits.BCLIP
    #define IPR2_LVDIP          IPR2bits.LVDIP
    #define IPR2_TMR3IP         IPR2bits.TMR3IP
    #define IPR2_ECCP1IP        IPR2bits.ECCP1IP
    // IPR3 register
    #define IPR3_IRXIP          IPR3bits.IRXIP
    #define IPR3_WAKIP          IPR3bits.WAKIP
    #define IPR3_ERRIP          IPR3bits.ERRIP
    #define IPR3_TXB2IP         IPR3bits.TXB2IP
    #define IPR3_TXB1IP         IPR3bits.TXB1IP
    #define IPR3_TXB0IP         IPR3bits.TXB0IP
    #define IPR3_RXB1IP         IPR3bits.RXB1IP
    #define IPR3_RXB0IP         IPR3bits.RXB0IP

#else
// HITECH_C18

    // __________ PORTS __________

    // PORTA register
    #define PORTA_RA0           RA0
    #define PORTA_RA1           RA1
    #define PORTA_RA2           RA2
    #define PORTA_RA3           RA3
    #define PORTA_RA4           RA4
    #define PORTA_RA5           RA5

    // PORTB register
    #define PORTB_RB0           RB0
    #define PORTB_RB1           RB1
    #define PORTB_RB2           RB2
    #define PORTB_RB3           RB3
    #define PORTB_RB4           RB4
    #define PORTB_RB5           RB5
    #define PORTB_RB6           RB6
    #define PORTB_RB7           RB7

    // PORTC register
    #define PORTC_RC0           RC0
    #define PORTC_RC1           RC1
    #define PORTC_RC2           RC2
    #define PORTC_RC3           RC3
    #define PORTC_RC4           RC4
    #define PORTC_RC5           RC5
    #define PORTC_RC6           RC6
    #define PORTC_RC7           RC7

    // CANCON register
    #define CANCON_REQOP2       REQOP2
    #define CANCON_REQOP1       REQOP1
    #define CANCON_REQOP0       REQOP0
    #define CANCON_ABAT         ABAT
    #define CANCON_WIN2         WIN2
    #define CANCON_WIN1         WIN1
    #define CANCON_WIN0         WIN0

    // CANSTAT register
    #define CANSTAT_OPMODE2     OPMODE2
    #define CANSTAT_OPMODE1     OPMODE1
    #define CANSTAT_OPMODE0     OPMODE0
    #define CANSTAT_ICODE2      ICODE2
    #define CANSTAT_ICODE1      ICODE1
    #define CANSTAT_ICODE0      ICODE0

    // COMSTAT register
    #define COMSTAT_RXB0OVFL    RXB0OVFL
    #define COMSTAT_RXB1OVFL    RXB1OVFL
    #define COMSTAT_TXB0        TXB0
    #define COMSTAT_TXBP        TXBP
    #define COMSTAT_RXBP        RXBP
    #define COMSTAT_TXWARN      TXWARN
    #define COMSTAT_RXWARN      RXWARN
    #define COMSTAT_EWARN       EWARN

    // TXB0CON register
    #define TXB0CON_TXABT       TXB0ABT
    #define TXB0CON_TXLARB      TXB0LARB
    #define TXB0CON_TXERR       TXB0ERR
    #define TXB0CON_TXREQ       TXB0REQ
    #define TXB0CON_TXPRI1      TXB0PRI1
    #define TXB0CON_TXPRI0      TXB0PRI0
    // TXB1CON register
    #define TXB1CON_TXABT       TXB1ABT
    #define TXB1CON_TXLARB      TXB1LARB
    #define TXB1CON_TXERR       TXB1ERR
    #define TXB1CON_TXREQ       TXB1REQ
    #define TXB1CON_TXPRI1      TXB1PRI1
    #define TXB1CON_TXPRI0      TXB1PRI0
    // TXB2CON register
    #define TXB2CON_TXABT       TXB2ABT
    #define TXB2CON_TXLARB      TXB2LARB
    #define TXB2CON_TXERR       TXB2ERR
    #define TXB2CON_TXREQ       TXB2REQ
    #define TXB2CON_TXPRI1      TXB2PRI1
    #define TXB2CON_TXPRI0      TXB2PRI0

    // TXB0SIDL register
    #define TXB0SIDL_EXIDE      TXB0EXIDE
    // TXB1SIDL register
    #define TXB1SIDL_EXIDE      TXB1EXIDE
    // TXB2SIDL register
    #define TXB2SIDL_EXIDE      TXB2EXIDE
    
    // TXB0DLC register
    #define TXB0DLC_TXRTR       TXB0RTR
    // TXB1DLC register
    #define TXB1DLC_TXRTR       TXB1RTR
    // TXB2DLC register
    #define TXB2DLC_TXRTR       TXB2RTR

    // RXB0CON register
    #define RXB0CON_RXFUL       RXB0FUL
    #define RXB0CON_RXM1        RXB0M1
    #define RXB0CON_RXM0        RXB0M0
    #define RXB0CON_RXRTRRO     RXB0RTRR0
    #define RXB0CON_RXB0DBEN    RXB0DBEN
    #define RXB0CON_JTOFF       JTOFF
    #define RXB0CON_FILHIT0     RXB0FILHIT0
    // RXB1CON register
    #define RXB1CON_RXFUL       RXB1FUL
    #define RXB1CON_RXM1        RXB1M1
    #define RXB1CON_RXM0        RXB1M0
    #define RXB1CON_RXRTRRO     RXB1RTRR0
    #define RXB1CON_FILHIT2     RXB1FILHIT2
    #define RXB1CON_FILHIT1     RXB1FILHIT1
    #define RXB1CON_FILHIT0     RXB1FILHIT0

    // RXB0SIDL register
    #define RXB0SIDL_SRR        RXB0SRR
    #define RXB0SIDL_EXID       RXB0EXID
    // RXB1SIDL register
    #define RXB1SIDL_SRR        RXB1SRR
    #define RXB1SIDL_EXID       RXB1EXID

    // RXB0DLC register
    #define RXB0DLC_RXRTR       RXB0RTR
    #define RXB0DLC_RB1         RXB0RB1
    #define RXB0DLC_RB0         RXB0RB0
    // RXB1DLC register
    #define RXB1DLC_RXRTR       RXB1RTR
    #define RXB1DLC_RB1         RXB1RB1
    #define RXB1DLC_RB0         RXB1RB0

    // RXF0SIDL register
    #define RXF0SIDL_EXIDEN     RXF0EXIDEN
    // RXF1SIDL register
    #define RXF1SIDL_EXIDEN     RXF1EXIDEN
    // RXF2SIDL register
    #define RXF2SIDL_EXIDEN     RXF2EXIDEN
    // RXF3SIDL register
    #define RXF3SIDL_EXIDEN     RXF3EXIDEN
    // RXF4SIDL register
    #define RXF4SIDL_EXIDEN     RXF4EXIDEN
    // RXF5SIDL register
    #define RXF5SIDL_EXIDEN     RXF5EXIDEN

    // BRGCON1 register
    #define BRGCON1_SJW1        SJW1
    #define BRGCON1_SJW0        SJW0
    #define BRGCON1_BRP5        BRP5
    #define BRGCON1_BRP4        BRP4
    #define BRGCON1_BRP3        BRP3
    #define BRGCON1_BRP2        BRP2
    #define BRGCON1_BRP1        BRP1
    #define BRGCON1_BRP0        BRP0

    // BRGCON2 register
    #define BRGCON2_SEG2PHTS    SEG2PHT
    #define BRGCON2_SAM         SAM
    #define BRGCON2_SEG1PH2     SEG1PH2
    #define BRGCON2_SEG1PH1     SEG1PH1
    #define BRGCON2_SEG1PH0     SEG1PH0
    #define BRGCON2_PRSEG2      PRSEG2
    #define BRGCON2_PRSEG1      PRSEG1
    #define BRGCON2_PRSEG0      PRSEG0

    // BRGCON3 register
    #define BRGCON3_WAKFIL      WAKFIL
    #define BRGCON3_SEG2PH2     SEG2PH2
    #define BRGCON3_SEG2PH1     SEG2PH1
    #define BRGCON3_SEG2PH0     SEG2PH0

    // __________ USART MODULE __________

    // TXSTA register
    #define TXSTA_CSRC          CSRC
    #define TXSTA_TX9           TX9
    #define TXSTA_TXEN          TXEN
    #define TXSTA_SYNC          SYNC
    #define TXSTA_BRGH          BRGH
    #define TXSTA_TRMT          TRMT
    #define TXSTA_TX9D          TX9D

    // RCSTA register
    #define RCSTA_SPEN          SPEN
    #define RCSTA_RX9           RX9
    #define RCSTA_SREN          SREN
    #define RCSTA_CREN          CREN
    #define RCSTA_ADDEN         ADDEN
    #define RCSTA_FERR          FERR
    #define RCSTA_OERR          OERR
    #define RCSTA_RX9D          RX9D

    // __________ ADC MODULE __________

    // ADCON0 register
    #define ADCON0_ADCS1        ADCS1
    #define ADCON0_ADCS0        ADCS0
    #define ADCON0_CHS2         CHS2
    #define ADCON0_CHS1         CHS1
    #define ADCON0_CHS0         CHS0
    #define ADCON0_GO           GODONE
    #define ADCON0_ADON         ADON

    // ADCON1 register
    #define ADCON1_ADFM         ADFM
    #define ADCON1_ADCS2        ADCS2
    #define ADCON1_PCFG3        PCFG3
    #define ADCON1_PCFG2        PCFG2
    #define ADCON1_PCFG1        PCFG1
    #define ADCON1_PCFG0        PCFG0

    // __________ TIMER MODULES __________

    // T0CON register
    #define T0CON_TMR0ON        TMR0ON
    #define T0CON_T08BIT        T08BIT
    #define T0CON_T0CS          T0CS
    #define T0CON_T0SE          T0SE
    #define T0CON_PSA           PSA
    #define T0CON_T0PS2         T0PS2
    #define T0CON_T0PS1         T0PS1
    #define T0CON_T0PS0         T0PS0
    
    // T1CON register
    #define T1CON_RD16          RD16
    #define T1CON_T1CKPS1       T1CKPS1
    #define T1CON_T1CKPS0       T1CKPS0
    #define T1CON_T1OSCEN       T1OSCEN
    #define T1CON_T1SYNC        T1SYNC
    #define T1CON_TMR1CS        TMR1CS
    #define T1CON_TMR1ON        TMR1ON

    // T2CON register
    #define T2CON_TOUTPS3       TOUTPS3
    #define T2CON_TOUTPS2       TOUTPS2
    #define T2CON_TOUTPS1       TOUTPS1
    #define T2CON_TOUTPS0       TOUTPS0
    #define T2CON_TMR2ON        TMR2ON
    #define T2CON_T2CKPS1       T2CKPS1
    #define T2CON_T2CKPS0       T2CKPS0

    // T3CON register
    #define T3CON_RD16          T3RD16
    #define T3CON_T3ECCP1       T3ECCP1
    #define T3CON_T3CKPS1       T3CKPS1
    #define T3CON_T3CKPS0       T3CKPS0
    #define T3CON_T3CCP1        T3CCP1
    #define T3CON_T3SYNC        T3SYNC
    #define T3CON_TMR3CS        TMR3CS
    #define T3CON_TMR3ON        TMR3ON

    // __________ INTERRUPT MODULES __________
    
    // INTCON register
    #define INTCON_GIE          GIE
    #define INTCON_PEIE         PEIE
    #define INTCON_GIEH         GIEH
    #define INTCON_GIEL         GIEL
    #define INTCON_TMR0IE       TMR0IE
    #define INTCON_INT0IE       INT0IE
    #define INTCON_RBIE         RBIE
    #define INTCON_TMR0IF       TMR0IF
    #define INTCON_INT0IF       INT0IF
    #define INTCON_RBIF         RBIF
    // INTCON2 register
    #define INTCON2_RBPU        RBPU
    #define INTCON2_INTEDG0     INTEDG0
    #define INTCON2_INTEDG1     INTEDG1
    #define INTCON2_TMR0IP      TMR0IP
    #define INTCON2_RBIP        RBIP
    // INTCON3 register
    #define INTCON3_INT2IP      INT2IP
    #define INTCON3_INT1IP      INT1IP
    #define INTCON3_INT2IE      INT2IE
    #define INTCON3_INT1IE      INT1IE
    #define INTCON3_INT2IF      INT2IF
    #define INTCON3_INT1IF      INT1IF

    // RCON register
    #define RCON_IPEN           IPEN
    #define RCON_RI             RI
    #define RCON_TO             TO
    #define RCON_PD             PD
    #define RCON_POR            POR
    #define RCON_BOR            BOR

    // PIR1 register
    #define PIR1_PSPIF          PSPIF
    #define PIR1_ADIF           ADIF
    #define PIR1_RCIF           RCIF
    #define PIR1_TXIF           TXIF
    #define PIR1_SSPIF          SSPIF
    #define PIR1_CCP1IF         CCP1IF
    #define PIR1_TMR2IF         TMR2IF
    #define PIR1_TMR1IF         TMR1IF
    // PIR2 register
    #define PIR2_CMIF           CMIF
    #define PIR2_EEIF           EEIF
    #define PIR2_BCLIF          BCLIF
    #define PIR2_LVDIF          LVDIF
    #define PIR2_TMR3IF         TMR3IF
    #define PIR2_ECCP1IF        ECCP1IF
    // PIR3 register
    #define PIR3_IRXIF          IRXIF
    #define PIR3_WAKIF          WAKIF
    #define PIR3_ERRIF          ERRIF
    #define PIR3_TXB2IF         TXB2IF
    #define PIR3_TXB1IF         TXB1IF
    #define PIR3_TXB0IF         TXB0IF
    #define PIR3_RXB1IF         RXB1IF
    #define PIR3_RXB0IF         RXB0IF

    // PIE1 register
    #define PIE1_PSPIE          PSPIE
    #define PIE1_ADIE           ADIE
    #define PIE1_RCIE           RCIE
    #define PIE1_TXIE           TXIE
    #define PIE1_SSPIE          SSPIE
    #define PIE1_CCP1IE         CCP1IE
    #define PIE1_TMR2IE         TMR2IE
    #define PIE1_TMR1IE         TMR1IE
    // PIE2 register
    #define PIE2_CMIE           CMIE
    #define PIE2_EEIE           EEIE
    #define PIE2_BCLIE          BCLIE
    #define PIE2_LVDIE          LVDIE
    #define PIE2_TMR3IE         TMR3IE
    #define PIE2_ECCP1IE        ECCP1IE
    // PIE3 register
    #define PIE3_IRXIE          IRXIE
    #define PIE3_WAKIE          WAKIE
    #define PIE3_ERRIE          ERRIE
    #define PIE3_TXB2IE         TXB2IE
    #define PIE3_TXB1IE         TXB1IE
    #define PIE3_TXB0IE         TXB0IE
    #define PIE3_RXB1IE         RXB1IE
    #define PIE3_RXB0IE         RXB0IE

    // IPR1 register
    #define IPR1_PSPIP          PSPIP
    #define IPR1_ADIP           ADIP
    #define IPR1_RCIP           RCIP
    #define IPR1_TXIP           TXIP
    #define IPR1_SSPIP          SSPIP
    #define IPR1_CCP1IP         CCP1IP
    #define IPR1_TMR2IP         TMR2IP
    #define IPR1_TMR1IP         TMR1IP
    // IPR2 register
    #define IPR2_CMIP           CMIP
    #define IPR2_EEIP           EEIP
    #define IPR2_BCLIP          BCLIP
    #define IPR2_LVDIP          LVDIP
    #define IPR2_TMR3IP         TMR3IP
    #define IPR2_ECCP1IP        ECCP1IP
    // IPR3 register
    #define IPR3_IRXIP          IRXIP
    #define IPR3_WAKIP          WAKIP
    #define IPR3_ERRIP          ERRIP
    #define IPR3_TXB2IP         TXB2IP
    #define IPR3_TXB1IP         TXB1IP
    #define IPR3_TXB0IP         TXB0IP
    #define IPR3_RXB1IP         RXB1IP
    #define IPR3_RXB0IP         RXB0IP
#endif

#endif
