#include "mymaths.h"

static const signed int sino_table[91] = {  0,
                                            17,
                                            35,
                                            52,
                                            70,
                                            87,
                                            105,
                                            122,
                                            139,
                                            156,
                                            174,
                                            191,
                                            208,
                                            225,
                                            242,
                                            259,
                                            276,
                                            292,
                                            309,
                                            326,
                                            342,
                                            358,
                                            375,
                                            391,
                                            407,
                                            423,
                                            438,
                                            454,
                                            469,
                                            485,
                                            500,
                                            515,
                                            530,
                                            545,
                                            559,
                                            574,
                                            588,
                                            602,
                                            616,
                                            629,
                                            643,
                                            656,
                                            669,
                                            682,
                                            695,
                                            707,
                                            719,
                                            731,
                                            743,
                                            755,
                                            766,
                                            777,
                                            788,
                                            799,
                                            809,
                                            819,
                                            829,
                                            839,
                                            848,
                                            857,
                                            866,
                                            875,
                                            883,
                                            891,
                                            899,
                                            906,
                                            914,
                                            921,
                                            927,
                                            934,
                                            940,
                                            946,
                                            951,
                                            956,
                                            961,
                                            966,
                                            970,
                                            974,
                                            978,
                                            982,
                                            985,
                                            988,
                                            990,
                                            993,
                                            995,
                                            996,
                                            998,
                                            999,
                                            999,
                                            1000,
                                            1000    };


unsigned int abs(signed int val)
{
    if (val<0)  val*=-1;
    return val;
}

signed int seno(signed int alpha)
{
    signed int res;

    // Normalizao do ngulo entre -180 e +180 graus
    alpha=alpha%360;
    if (alpha>180)          alpha-=360;
    else if (alpha<-180)    alpha+=360;

    // Condies de equivalncia (alpha=[-90,+90])
    if (alpha>90)       alpha= 180-alpha;
    else if (alpha<-90) alpha=-180-alpha;

    // Mdulo do resultado
    res=sino_table[abs(alpha)];

    // Correco do resultado
    if (alpha<0)  res*=-1;

    return res;
}

signed int coseno(signed int alpha)
{
    return seno(90-alpha);
}
