#ifndef _MYMATHS__H
#define _MYMATHS__H

#define PI          3.14159265359

#define DEGREE(x)   ((x)*180.0/PI)
#define RADIAN(x)   ((x)*PI/180.0)

// Produto de uma amplitude com um factor trigonomtrico e sua normalizao.
#define TRIG_NORMAL(amp,trig)     ((signed long) (amp)*(trig)/(signed long) 1000)
#define SENO_NORMAL(amp,alpha)    ((signed long) (amp)*seno(alpha)/(signed long) 1000)
#define COSENO_NORMAL(amp,alpha)  ((signed long) (amp)*coseno(alpha)/(signed long) 1000)

// Outras Macros
#define sqr(x)      ((x)*(x))                       // Quadrado
#define cube(x)     (sqr(x)*(x))                    // Cubo
#define sign(x)     ((signed char) ((x)>=0)*2-1)    // Sinal: +1 (positivo) ou -1 (negativo)

extern unsigned int abs(signed int val);

extern signed int seno(signed int alpha);

extern signed int coseno(signed int alpha);

#endif
