/*=======================================================================+
|             DEPARTAMENTO MECANICA UNIVERSIDADE AVEIRO                  |
|               Projecto Humanoide (PHUA - MODULROB)                     |
|                                                                        |
| Programadores:                                                         |
|              Milton Ruas da Silva                N:21824               |
|              David Manuel Costa Gameiro          N:20281               |
|              Filipe Carvalho Mostardinha         N:22085               |
|                                                                        |
| Nome Ficheiro: MasterPrinc.c                                           |
|                                                                        |
|                            SOURCE FILE                                 |
+=======================================================================*/

#include "pic2.h"
#include "servo.h"
#include "trajectory.h"

void main(void)
{
    unsigned char i;
    unsigned char str[]="\r\nHumanoid Robot!\r\n";

    // Inicializao das estruturas globais
    initGlobal();

    //inicializacao dos mdulos PIC2 e SERVO
    initPic();

    // Inicializao dos valores iniciais dos sensores e actuadores
    initSensorsActuators();

    for (;;)  {  

        sendStr(str);
        
        // Desactivao do sinal de PWM
        statusPWM(false,-1);

        // Esperar que o sinal de PWM seja autorizado a activar-se
        while (!actuators.sysStatus.pwm);  

        // Calibrao dos servos
        calibration();
    
        // Inicializao do gerador de trajectrias
        initTrajectory();
    
        // Inicializao do Controlador PID
        initController();
    
        while (actuators.sysStatus.pwm)  {
            waitTick();
    
            TESTPIN=1;
            
            // Aplicao de uma trajectria
            trajectory();
    
            // Controlador
            controller();

            TESTPIN=0;
    
            // Verificao da ocorrncia de violao de Deadline
            if (timeTick)  sensors.sysStatus.deadlineError=true;
        }
    }
}
