% Adaptao dos angulos solicitados ao que os motores requerem
%
% pos_final=adaptate(scuid,position)
%
% scuid    -> ID do slave
% position -> Posio solicitada (para os tres servos)
% pos_final-> Posio a aplicar aos servos
%
% Note que a correco nem a limitao  executada.

function pos_final=adaptate(scuid,position,Nrel,servo)

% Preenchimento de algum argumento no fornecido
if (nargin<4)
    servo=1;
end
if (nargin<3)
    Nrel=1;
end

% Sinal a adicionar as posies solicitadas
signal=[-1 +1 +1;
        +1 +1 -1;
        -1 +1 +1;
        -1 +1 +1];

% Offset a adicionar as posies solicitadas
offset=[   0   0 -70;
           0   0 +70;
           0   0   0;
           0   0   0];

% Validao dos argumentos
if (scuid<1 || size(position,2)>min(size(signal,2),size(offset,2)))
    error('limit fcn:invalid arg','Argumentos invlidos!');
end
if (scuid>min(size(signal,1),size(offset,1)))
    pos_final=position;
    return;
end

N=size(position,1);
pos_final=zeros(N,3);

for i=1:N
    if (servo>0)
        % Adapato da posio solicitada para aplicao aos motores
        pos_final(i,:) = position(i,:).*signal(scuid,:)*Nrel + offset(scuid,:);
    else
        % Adaptao da posio lido nos motores para a das juntas
        pos_final(i,:) = (position(i,:)-offset(scuid,:)).*signal(scuid,:)/Nrel;
    end
end