% Limitao das posies a aplicar a determinado SCU
%
% position_final=limit(scuid,position)
% Entrada:
%   scuid: id do SCU a aplicar as posies
%   position: lista de posies a aplicar s 3 juntas
% Sada:
%   position_final: posio limitada a aplicar s juntas

function [position,error,errorstr]=validate(scuid,position)

error=0;
errorstr='OK';

% Posies limite a aplicar a cada SCU
posmin=[-90 -90 -90;
        -90 -90 -90;
        -90 -90 -90;
        -90 -90 -90];

posmax=[ 90  90  90;
         90  90  90;
         90  90  90;
         90  90  90];

% Validao dos argumentos
if (scuid<0 || scuid>min(size(posmin,1),size(posmax,1)))
    error('limit fcn:invalid arg','Argumentos invlidos!');
end

N=size(position,1);

error=0;
for k=1:N

    % Verificao de uma situao de limitao
    error=error | (sum((position(k,:)<posmin(scuid,:))+(position(k,:)>posmax(scuid,:)))>0);
    
    % Limitao das posies
    position(k,:)=(position(k,:)<posmin(scuid,:)).*posmin(scuid,:)+ ...
                  (position(k,:)>posmax(scuid,:)).*posmax(scuid,:)+ ...
                  ((position(k,:)>=posmin(scuid,:)) & (position(k,:)<=posmax(scuid,:))).*position(k,:);    
end

if (error==1)
    errorstr='Posies limitadas!';
end