% Script de correco das posies aplicadas nas juntas
%
% position_final=correct(scuid,position)
% Entrada:
%   scuid: id do SCU a aplicar as posies
%   position: lista de posies a aplicar s 3 juntas
% Sada:
%   position_final: posio corrigida a aplicar s juntas

function position_final=correct(scuid,position,servo)

if (nargin<3)
    servo=1;
end

% Desvios de posio de cada unidade de controlo
calib=[  0   0   0;       % SCU 1: Perna direedit ita  (tornozelo + p + joelho)
        10  -5   0;       % SCU 2: Perna esquerda (tornozelo + p + joelho)
         0   0   0;       % SCU 3: Anca direita   (mov. dianteiro + lateral + rotativo)
         8   0   0];      % SCU 4: Anca esquerdo  (mov. dianteiro + lateral + rotativo)

% Validao dos argumentos
if (scuid<1 || size(position,2)~=size(calib,2))
    error('correct fcn:invalid arg','Argumentos invlidos!');
end
if (scuid>size(calib,1))
    position_final=position;
    return;
end

N=size(position,1);
position_final=zeros(N,3);

for i=1:N
    % Correo das posies solicitadas
    if (servo>0)
        position_final(i,:)=position(i,:)+calib(scuid,:);
    else
        position_final(i,:)=position(i,:)-calib(scuid,:);
    end
end