//*****************************************************************************
// COM.H
//
// Dep. Electronica da Universidade de Aveiro
// Jose Luis Azevedo & Milton Ruas da Silva
//
// Mar/2004
//*****************************************************************************

#ifndef _COM_H
#define _COM_H

#define START		'@'			// Communication beginning
#define END			'&'			// Communication ending
#define SEP			','			// Line separator
#define SOF			'_'			// Start of frame character
#define EOF			'\n'		// End of Frame sequence

//*****************************************************************************
// Inicializacao da USART
//
extern void initUsart(void);

//*****************************************************************************
// Funcao para envio de um caracter para a porta serie
//
extern void sendChar(unsigned char ch);

//*****************************************************************************
// Funcao para envio da string apontada por "str" para a porta serie
//
extern void sendStr(const unsigned char *str);

//*****************************************************************************
// Funcao para envio de um array para a porta serie
// 
void sendArray(const unsigned char *array, unsigned int n);

//*****************************************************************************
// Funcao para envio de um valor, sem sinal, para a porta serie, em qq base
//
extern void sendVal(unsigned int val, unsigned char base);

//*****************************************************************************
// Funcao para envio de um valor, com sinal, para a porta serie, em qq base
//
extern void sendValSign(signed int val, unsigned char base);

//*****************************************************************************
// Funcao para leitura de um caracter da porta serie
//
extern unsigned char getChar(void);

//*****************************************************************************
// Funcao no bloqueante para leitura de um caracter da porta serie
//
extern unsigned char getKey(void);

//*****************************************************************************
// Funcao para leitura de uma string da porta serie
//
extern void getStr(unsigned char *str, unsigned int nchar);

//*****************************************************************************
// Funcao para leitura de um valor inteiro positivo da porta serie
//
extern signed int getVal(unsigned char base);

#endif
