#include "mymaths.h"

rom const signed int sino_table[91] =    {  0,
                                            17,
                                            35,
                                            52,
                                            70,
                                            87,
                                            105,
                                            122,
                                            139,
                                            156,
                                            174,
                                            191,
                                            208,
                                            225,
                                            242,
                                            259,
                                            276,
                                            292,
                                            309,
                                            326,
                                            342,
                                            358,
                                            375,
                                            391,
                                            407,
                                            423,
                                            438,
                                            454,
                                            469,
                                            485,
                                            500,
                                            515,
                                            530,
                                            545,
                                            559,
                                            574,
                                            588,
                                            602,
                                            616,
                                            629,
                                            643,
                                            656,
                                            669,
                                            682,
                                            695,
                                            707,
                                            719,
                                            731,
                                            743,
                                            755,
                                            766,
                                            777,
                                            788,
                                            799,
                                            809,
                                            819,
                                            829,
                                            839,
                                            848,
                                            857,
                                            866,
                                            875,
                                            883,
                                            891,
                                            899,
                                            906,
                                            914,
                                            921,
                                            927,
                                            934,
                                            940,
                                            946,
                                            951,
                                            956,
                                            961,
                                            966,
                                            970,
                                            974,
                                            978,
                                            982,
                                            985,
                                            988,
                                            990,
                                            993,
                                            995,
                                            996,
                                            998,
                                            999,
                                            999,
                                            1000,
                                            1000    };

rom const signed int asino_table[101] = { 	  0,
                                              1,
                                              1,
                                              2,
                                              2,
                                              3,
                                              3,
                                              4,
                                              5,
                                              5,
                                              6,
                                              6,
                                              7,
                                              7,
                                              8,
                                              9,
                                              9,
                                              10,
                                              10,
                                              11,
                                              12,
                                              12,
                                              13,
                                              13,
                                              14,
                                              14,
                                              15,
                                              16,
                                              16,
                                              17,
                                              17,
                                              18,
                                              19,
                                              19,
                                              20,
                                              20,
                                              21,
                                              22,
                                              22,
                                              23,
                                              24,
                                              24,
                                              25,
                                              25,
                                              26,
                                              27,
                                              27,
                                              28,
                                              29,
                                              29,
                                              30,
                                              31,
                                              31,
                                              32,
                                              33,
                                              33,
                                              34,
                                              35,
                                              35,
                                              36,
                                              37,
                                              38,
                                              38,
                                              39,
                                              40,
                                              41,
                                              41,
                                              42,
                                              43,
                                              44,
                                              44,
                                              45,
                                              46,
                                              47,
                                              48,
                                              49,
                                              49,
                                              50,
                                              51,
                                              52,
                                              53,
                                              54,
                                              55,
                                              56,
                                              57,
                                              58,
                                              59,
                                              60,
                                              62,
                                              63,
                                              64,
                                              66,
                                              67,
                                              68,
                                              70,
                                              72,
                                              74,
                                              76,
                                              79,
                                              82,
                                              90	};


unsigned int abs(signed int val)
{
    if (val<0)  val*=-1;
    return val;
}

signed int seno(signed int alpha)
{
    signed int res;

    // Normalizao do ngulo entre -180 e +180 graus
    alpha=alpha%360;
    if (alpha>180)          alpha-=360;
    else if (alpha<-180)    alpha+=360;

    // Condies de equivalncia (alpha=[-90,+90])
    if (alpha>90)       alpha= 180-alpha;
    else if (alpha<-90) alpha=-180-alpha;

    // Mdulo do resultado
    res=sino_table[abs(alpha)];

    // Correco do resultado
    if (alpha<0)  res*=-1;

    return res;
}

signed int coseno(signed int alpha)
{
    return seno(90-alpha);
}


signed int aseno(signed int value)
{
	signed int res;
	
	if (value<-100 || value>100)
		return 0;
		
	if (value < 0)
		res = -asino_table[abs(value)];
	else
		res = asino_table[value];
		
	return res;
		
}
